class Schokidrucker{

  private:
    //Position
    float X_aktuell;
    float Y_aktuell;
    float X_Start;
    float Y_Start;

    //Stepper
    int X_Richtung;
    int Y_Richtung;
    int Grunddelay;
    int X_Stepper_Pin;
    int Y_Stepper_Pin;
    int X_Richtung_Pin;
    int Y_Richtung_Pin;
    int Pixelumrechnung;

    //Spritze
    int Spritze_Geschwindigkeit;
    int Spritze_Richtung;
    int Spritze_Pin_Hoch;
    int Spritze_Pin_Runter;
    int Spritze_Pin_Geschwindigkeit;
    int Druck;

    public:
      //Konstruktor
      Schokidrucker(int x, int y, int Xpin, int Ypin, int XrP, int YrP, int pixel, int SpH, int SpR, int SpG);
                 //(Startposition x, y,  Stepperpin für x, y,  Richtungspin für x, y,  Pixelumrechnung, Pin SpritzeHoch, Pin SpritzeRunter, Pin SpritzeGeschwindigkeit)
      
      //Geter und Seter
      int GetX();
      int GetY();
      int GetStartX();
      int GetStartY();
      void SetStartX(int x);
      void SetStartY(int y);
      void StartingPosition(int x, int y);
      void Calibrate(int x, int y);
      void SetDelay(int d);
      int GetDelay();
      int GetXPin();
      int GetYPin();
      int GetXRPin();
      int GetYRPin();
      void SetXPin(int pin);
      void SetYPin(int pin);
      void SetXRPin(int pin);
      void SetYRPin(int pin);
      void SetXRichtung(int r);
      void SetYRichtung(int r);
      int GetXRichtung();
      int GetYRichtung();
      int GetPixel();
      void SetPixel(int p);

      int SpritzeGetSpeed();
      void SpritzeSetSpeed(int v);
      int SpritzeGetRichtung();
      void SpritzeSetRichtung(int r);
      int SpritzeGetPinHoch();
      void SpritzeSetPinHoch(int pin);
      int SpritzeGetPinRunter();
      void SpritzeSetPinRunter(int pin);
      int GetDruck();
      void SetDruck(int d);
      

      //Befehle
      void Goto(int x, int y);         //geht erst in x- und dann in y-Richtung zu einer übergebenen Koordinate
      void MakeLine(float x, float y); //geht direkt zu einer übergebenen Koordinate (wichtig für Diagonalen, aber evtl mit Ungenauigkeiten durch Rundungen)
      void Print(float x[], float y[], int laenge, int anzahl); //druckt eine Menge von Linien (Beschreibung zu geforderten Parametern unten)
      void SchokoLos();               //bewegt Spritzenkolben nach unten
      void SchokoStop();              //zieht Spritzenkolben ein Stück nach oben
      void Stop();                    //stoppt Stepper und Linearaktor (= Spritzenkolben)
      void FullStop();                //stoppt Stepper und zieht Spritzenkolben ein Stück nach oben
      void End();                     //stoppt alles und beendet das Programm
      void StartingPosition();        //geht zurück zur Startposition

      void SpritzeStop();             //stoppt Linearaktor
      void SpritzeHoch(int v);        //Linearaktor zieht Spritzenkolben mit der übergebenen Geschwindigkeit v nach oben
      void SpritzeRunter(int v);      //Linearaktor drückt Spritzenkolben mit der übergebenen Geschwindigkeit v nach unten
      void SpritzeMove();             //Linearaktor bewegt Spritzenkolben mit Spritze_Geschwindigkeit
       
};

Schokidrucker::Schokidrucker(int x, int y, int Xpin, int Ypin, int XrP, int YrP, int pixel, int SpH, int SpR, int SpG){
  //Position
    X_aktuell = x;
    Y_aktuell = y;
    X_Start = x;
    Y_Start = y;

    //Stepper
    X_Richtung = 1;
    Y_Richtung = 1;
    Grunddelay = 1000;
    X_Stepper_Pin = Xpin;
    Y_Stepper_Pin = Ypin;
    X_Richtung_Pin = XrP;
    Y_Richtung_Pin = YrP;
    Pixelumrechnung = pixel;

    //Spritze
    Spritze_Geschwindigkeit = 0;
    Spritze_Richtung = -1;
    Spritze_Pin_Hoch = SpH;
    Spritze_Pin_Runter = SpR;
    Spritze_Pin_Geschwindigkeit = SpG;
    Druck = 50;

    pinMode(X_Stepper_Pin,OUTPUT);
    pinMode(Y_Stepper_Pin,OUTPUT);
    pinMode(X_Richtung_Pin,OUTPUT);
    pinMode(Y_Richtung_Pin,OUTPUT);
    pinMode(Spritze_Pin_Hoch,OUTPUT);
    pinMode(Spritze_Pin_Runter,OUTPUT);
    pinMode(Spritze_Pin_Geschwindigkeit,OUTPUT);
  
}


int Schokidrucker::GetX(){
  return X_aktuell;
}
int Schokidrucker::GetY(){
  return Y_aktuell;
}
int Schokidrucker::GetStartX(){
  return X_Start;
}
int Schokidrucker::GetStartY(){
  return Y_Start;
}
void Schokidrucker::SetStartX(int x){
  X_Start = x;
}
void Schokidrucker::SetStartY(int y){
  Y_Start = y;
}
void Schokidrucker::StartingPosition(int x, int y){
  X_aktuell = x;
  Y_aktuell = y;
  X_Start = x;
  Y_Start = y;
}
void Schokidrucker::Calibrate(int x, int y){
  X_aktuell = x;
  Y_aktuell = y;
}
void Schokidrucker::SetDelay(int d){
  Grunddelay = d;
}
int Schokidrucker::GetDelay(){
  return Grunddelay;
}
int Schokidrucker::GetXPin(){
  return X_Stepper_Pin;
}
int Schokidrucker::GetYPin(){
  return Y_Stepper_Pin;
}
int Schokidrucker::GetXRPin(){
  return X_Richtung_Pin;
}
int Schokidrucker::GetYRPin(){
  return Y_Richtung_Pin;
}
void Schokidrucker::SetXPin(int pin){
  X_Stepper_Pin = pin;
}
void Schokidrucker::SetYPin(int pin){
  Y_Stepper_Pin = pin;
}
void Schokidrucker::SetXRPin(int pin){
  X_Richtung_Pin = pin;
}
void Schokidrucker::SetYRPin(int pin){
  Y_Richtung_Pin = pin;
}
void Schokidrucker::SetXRichtung(int r){
  if(r<0){
    X_Richtung = -1;
    digitalWrite(X_Richtung_Pin, LOW);
  }
  else{
    X_Richtung = 1;
    digitalWrite(X_Richtung_Pin, HIGH);
  }
}

void Schokidrucker::SetYRichtung(int r){
  if(r<0){
    Y_Richtung = -1;
    digitalWrite(Y_Richtung_Pin, LOW);
  }
  else{
    Y_Richtung = 1;
    digitalWrite(Y_Richtung_Pin, HIGH);
  }
}

int Schokidrucker::GetXRichtung(){
  return X_Richtung;
}

int Schokidrucker::GetYRichtung(){
  return Y_Richtung;
}

int Schokidrucker::GetPixel(){
  return Pixelumrechnung;
}

void Schokidrucker::SetPixel(int p){
  Pixelumrechnung = p;
}

int Schokidrucker::SpritzeGetSpeed(){
  return Spritze_Geschwindigkeit;
}

void Schokidrucker::SpritzeSetSpeed(int v){
  Spritze_Geschwindigkeit = v;
}
int Schokidrucker::SpritzeGetRichtung(){
  return Spritze_Richtung;
}

void Schokidrucker::SpritzeSetRichtung(int r){
  if(r<0){
    Spritze_Richtung = -1;
    digitalWrite(Spritze_Pin_Hoch, HIGH);
    digitalWrite(Spritze_Pin_Runter, LOW);
  }
  if(r==0){
    Spritze_Richtung = 0;
    digitalWrite(Spritze_Pin_Hoch, LOW);
    digitalWrite(Spritze_Pin_Runter, LOW);
  }
  else{
    Spritze_Richtung = 1;
    digitalWrite(Spritze_Pin_Hoch, LOW);
    digitalWrite(Spritze_Pin_Runter, HIGH);
  }
}

int Schokidrucker::SpritzeGetPinHoch(){
  return Spritze_Pin_Hoch;
}

void Schokidrucker::SpritzeSetPinHoch(int pin){
  Spritze_Pin_Hoch = pin;
}
      
int Schokidrucker::SpritzeGetPinRunter(){
  return Spritze_Pin_Runter;
}

void Schokidrucker::SpritzeSetPinRunter(int pin){
  Spritze_Pin_Runter = pin;
}

int Schokidrucker::GetDruck(){
  return Druck;
}
void Schokidrucker::SetDruck(int d){
  Druck = d;
}

void Schokidrucker::Goto(int x, int y){
  int wegX = x-X_aktuell; //berechnet Abstand zwischen der neuen und der aktuellen x-Koordinate
  int wegY = y-Y_aktuell; //berechnet Abstand zwischen der neuen und der aktuellen y-Koordinate
  
  if(wegX<0) //je nach Richtung wird der Stepper auf HIGH oder LOW gesetzt
  {
    digitalWrite(X_Richtung_Pin, LOW); 
    wegX = wegX*(-1); //die Strecke wird in eine natürliche Zahl umgewandelt
  }
  else
  {
    digitalWrite(X_Richtung_Pin, HIGH);
  }

  if(wegY<0)  //je nach Richtung wird der Stepper auf HIGH oder LOW gesetzt
  {
    digitalWrite(Y_Richtung_Pin, LOW);
    wegY = wegY*(-1); //die Strecke wird in eine natürliche Zahl umgewandelt
  }
  else
  {
    digitalWrite(Y_Richtung_Pin, HIGH);
  }

  for (int i = 0; i < Pixelumrechnung*wegX; i++) //bewegt Platte zur übergebenen x-Koordinate
  {
    digitalWrite(X_Stepper_Pin, HIGH);
    delayMicroseconds(Grunddelay);
    digitalWrite(X_Stepper_Pin, LOW);
    delayMicroseconds(Grunddelay);
  }
  for (int i = 0; i < Pixelumrechnung*wegY; i++) //bewegt Platte zur übergebenen y-Koordinate
  {
    digitalWrite(Y_Stepper_Pin, HIGH);
    delayMicroseconds(Grunddelay);
    digitalWrite(Y_Stepper_Pin, LOW);
    delayMicroseconds(Grunddelay);
  }

  //die neue Position des Druckers wird gespeichert:
  X_aktuell = x; 
  Y_aktuell = y;
}



void Schokidrucker::MakeLine(float x, float y){
  float strecke_X = x - X_aktuell;  
  float strecke_Y = y - Y_aktuell;  
  float Intervall_X;  
  float Intervall_Y;  

  if (strecke_X < 0) //je nach Richtung wird der Stepper auf HIGH oder LOW gesetzt
  {
    digitalWrite(X_Richtung_Pin, LOW); 
    strecke_X = strecke_X * (-1); //die Strecke wird in eine natürliche Zahl umgewandelt
  }
  else
  {
    digitalWrite(X_Richtung_Pin, HIGH);
  }

  if (strecke_Y < 0) //je nach Richtung wird der Stepper auf HIGH oder LOW gesetzt
  {
    digitalWrite(Y_Richtung_Pin, LOW);
    strecke_Y = strecke_Y * (-1); //die Strecke wird in eine natürliche Zahl umgewandelt
  }
  else
  {
    digitalWrite(Y_Richtung_Pin, HIGH);
  }

  //delay für jeden Stepper wird errechnet
  if (strecke_X > strecke_Y)                          //wenn die Strecke, die in x-Richtung zurückgelegt werden muss größer ist als die in y-Richtung zurückzulegende Strecke, ... 
  {
    Intervall_X = Grunddelay;                           //...wird Intervall_X gleich dem Grunddelay gewählt
    Intervall_Y = Grunddelay * (strecke_X / strecke_Y); //...wird Intervall_Y so gewählt, dass es größer als Intervall_X und abhängig von den Längen der beiden Strecken ist
  }
  else                                                //im anderen Fall...
  {
    Intervall_Y = Grunddelay;                           //...wird Intervall_Y gleich dem Grunddelay gewählt
    Intervall_X = Grunddelay * (strecke_Y / strecke_X); //...wird Intervall_X so gewählt, dass es größer als Intervall_Y und abhängig von den Längen der beiden Strecken ist
  }

  unsigned long zeit_vorher_X = 0;
  bool modus_X = false;
  unsigned long zeit_vorher_Y = 0;
  bool modus_Y = false;
  int zaehlerX = 0;
  int zaehlerY = 0;

  unsigned long Zeit_aktuell = micros();
  zeit_vorher_X = Zeit_aktuell;
  zeit_vorher_Y = Zeit_aktuell;

  while (zaehlerX < strecke_X * Pixelumrechnung || zaehlerY < strecke_Y * Pixelumrechnung)
  {
    Zeit_aktuell = micros();

    if (Zeit_aktuell - zeit_vorher_X >= Intervall_X)
    {
      zeit_vorher_X = Zeit_aktuell;
      
      if (modus_X == false)
      {
        digitalWrite(X_Stepper_Pin, HIGH);
        modus_X = true;
      }

      else
      {
        digitalWrite(X_Stepper_Pin, LOW);
        modus_X = false;
        zaehlerX++;
      }
    }

    if (Zeit_aktuell - zeit_vorher_Y >= Intervall_Y)
    {
      zeit_vorher_Y = Zeit_aktuell;
      
      if (modus_Y == false)
      {
        digitalWrite(Y_Stepper_Pin, HIGH);
        modus_Y = true;
      }
      else 
      {
        digitalWrite(Y_Stepper_Pin, LOW);
        modus_Y = false;
        zaehlerY++;
      }
    }
  }
  
  //die neue Position des Druckers wird gespeichert:
  X_aktuell = x;
  Y_aktuell = y;
}


void Schokidrucker::Print(float x[], float y[], int laenge, int anzahl)
/*
 * x- und y-Koordinaten müssen in Form zweier Arrays übergeben werden (gleiche Stellen in Arrays entsprechen jeweils einem Punkt) 
 * Anzahl der Punkte müssen als laenge übergeben werden
 * anzahl speichert, wie häufig die Linien gedruckt werden sollen
 */
{
  SchokoLos();
  for(int a = 0; a<anzahl; a++)
  {
    for(int i = 0; i<laenge; i++)
    {
     MakeLine(x[i],y[i]);
    }
  }
  FullStop();
}

void Schokidrucker::SchokoLos(){
  digitalWrite(Spritze_Pin_Hoch, LOW);
  digitalWrite(Spritze_Pin_Runter, HIGH);
  analogWrite(Spritze_Pin_Geschwindigkeit, Druck);
}

void Schokidrucker::SchokoStop(){
  digitalWrite(Spritze_Pin_Hoch, HIGH);
  digitalWrite(Spritze_Pin_Runter, LOW);
  analogWrite(Spritze_Pin_Geschwindigkeit, 128);
  delay(2500);
  SpritzeStop();
}

void Schokidrucker::Stop(){
  digitalWrite(Spritze_Pin_Hoch, LOW);
  digitalWrite(Spritze_Pin_Runter, LOW);
  analogWrite(Spritze_Pin_Geschwindigkeit, 0);
  digitalWrite(X_Stepper_Pin, LOW);
  digitalWrite(Y_Stepper_Pin, LOW);
}

void Schokidrucker::FullStop(){
  digitalWrite(X_Stepper_Pin, LOW);
  digitalWrite(Y_Stepper_Pin, LOW);
  digitalWrite(Spritze_Pin_Hoch, HIGH);
  digitalWrite(Spritze_Pin_Runter, LOW);
  analogWrite(Spritze_Pin_Geschwindigkeit, 128);
  delay(2500);
  SpritzeStop();
}

void Schokidrucker::End(){
  digitalWrite(X_Stepper_Pin, LOW);
  digitalWrite(Y_Stepper_Pin, LOW);
  digitalWrite(Spritze_Pin_Hoch, LOW);
  digitalWrite(Spritze_Pin_Runter, LOW);
  analogWrite(Spritze_Pin_Geschwindigkeit, 0);
  while(true)
  {
    delay(1000);
  }
}

void Schokidrucker::StartingPosition(){
  Goto(X_Start,Y_Start);
}

void Schokidrucker::SpritzeStop(){
  digitalWrite(Spritze_Pin_Hoch, LOW);
  digitalWrite(Spritze_Pin_Runter, LOW);
  analogWrite(Spritze_Pin_Geschwindigkeit, 0);
}

void Schokidrucker::SpritzeHoch(int v){
  digitalWrite(Spritze_Pin_Hoch, HIGH);
  digitalWrite(Spritze_Pin_Runter, LOW);
  analogWrite(Spritze_Pin_Geschwindigkeit, v);
}

void Schokidrucker::SpritzeRunter(int v){
  digitalWrite(Spritze_Pin_Hoch, LOW);
  digitalWrite(Spritze_Pin_Runter, HIGH);
  analogWrite(Spritze_Pin_Geschwindigkeit, v);
}

void Schokidrucker::SpritzeMove(){
  analogWrite(Spritze_Pin_Geschwindigkeit, Spritze_Geschwindigkeit);
}
