//Werte der Form "x35y-20" werden übergeben, die Zielkoordinaten erhalten dann xZiel = 35, yZiel = -20. Es können aber auch einzelne Koordianten geschickt werden, es muss lediglich x oder y davorstehen

#include <string.h>
#include "Schokidrucker.hpp"

int ventil;        //ventil beinhaltet den Wert 0(es soll nicht gedruckt werden) oder 1 (es soll gedruckt werden)

float xZiel;      //nächste anzusteuernde x-Koordiante
float yZiel;      //nächste anzusteuernde y-Koordinate

Schokidrucker Drucker(0, 0, 3, 5, 2, 4, 50, 7, 6, 9); //(Startposition x, y,  Stepperpin für x, y,  Richtungspin für x, y,  Pixelumrechnung, Pin SpritzeHoch, Pin SpritzeRunter, Pin SpritzeGeschwindigkeit)
 
void setup()
{
  Serial.begin(115200); //Baudrate zwischen Processing und Arduino (muss bei beiden gleich sein!)
  Serial.write('0');    //Arduino ist bereit um Werte zu empfangen 
}


bool xBekommen = false; //speichert, ob die neue x-Koordinate gespeichert wurde
bool yBekommen = false; //speichert, ob die neue y-Koordinate gespeichert wurde


void loop()
{
  
  while (Serial.available() <= 0) {}    //auf Daten aus Processing warten
    int koordinaten = Serial.read();    //Daten aus Processing werden in koordinaten gespeichert und anschließend zerlegt
    switch (koordinaten)
    {
      case 'x':                          //wenn in der Zeichenfolge ein x gefunden wird,...
      {
        xZiel = Serial.parseFloat();     //...werden die nachfolgende(n) Zahl(en) als xZiel gespeichert
        xBekommen = true;
        break;
      }
      case 'y':                        //wenn in der Zeichenfolge ein y gefunden wird,...
      {
        yZiel = Serial.parseFloat();   //...werden die nachfolgende(n) Zahl(en) als yZiel gespeichert
        yBekommen = true;
        break;
      }
      case 'v':                        //wenn in der Zeichenfolge ein v gefunden wird,...
      {
        ventil = Serial.parseInt();    //...werden die nachfolgende(n) Zahl(en) als ventil gespeichert
        if (ventil == 1)
        {
          SpritzeRunter(128);
        }
        if (ventil == 0)
        {
          SpritzeHoch(128);
        } 
        break;
      }
      case 'e':                      //wenn in der Zeichenfolge ein e gefunden wird,...
      {
        // Drucker.SchokoStop();
        Drucker.StartingPosition();  //...geht der Drucker zurück auf seine Startposition...
        Drucker.End();               //...und beendet das Programm.
      }
      default:                        //wenn in der Zeichenfolge etwas gefunden wird, was nicht zugeordnet werden kann,...
        break;                        //...wird nichts gemacht
    }

    if(xBekommen&&yBekommen)           //wenn beide neuen Koordinaten übergeben worden sind, (1)
    {
      Serial.write('0'); //die neuen Werte aus Processing dürfen nun empfangen werden
      Drucker.MakeLine(xZiel, yZiel); //(2)darf die nächste Linie gedruckt werden
      xBekommen = false;         
      yBekommen = false;
    }
}
